#! /bin/sh
# This is a shell archive.  Remove anything before this line, then unpack
# it by saving it into a file and typing "sh file".  To overwrite existing
# files, type "sh file -c".  You can also feed this as standard input via
# unshar, or by typing "sh <file", e.g..  If this archive is complete, you
# will see the following message at the end:
#		"End of archive 1 (of 2)."
# Contents:  methods methods/Examples methods/Examples/adts
#   methods/Examples/adts/hashtbl.scm methods/Examples/adts/heap.sch
#   methods/Examples/adts/lin-tform.scm
#   methods/Examples/adts/queues.scm methods/Examples/adts/sets.scm
#   methods/Examples/dataflow methods/Examples/matrices
#   methods/Examples/matrices/vectors.scm
#   methods/Examples/receptionist
#   methods/Examples/receptionist/receptionist.s
#   methods/Examples/receptionist/receptionist.scm
#   methods/Examples/utils methods/Examples/utils/Stream.scm
#   methods/Examples/utils/assocl.scm
#   methods/Examples/utils/copy-list.scm
#   methods/Examples/utils/mouse-o-meter.scm
#   methods/Examples/utils/qsort.scm
#   methods/Examples/utils/shelsort.scm methods/methods.dox
#   methods/methods.s methods/methods.scm
# Wrapped by oz@yunexus on Wed May 22 12:03:10 1991
PATH=/bin:/usr/bin:/usr/ucb ; export PATH
if test ! -d 'methods' ; then
    echo shar: Creating directory \"'methods'\"
    mkdir 'methods'
fi
if test ! -d 'methods/Examples' ; then
    echo shar: Creating directory \"'methods/Examples'\"
    mkdir 'methods/Examples'
fi
if test ! -d 'methods/Examples/adts' ; then
    echo shar: Creating directory \"'methods/Examples/adts'\"
    mkdir 'methods/Examples/adts'
fi
if test -f 'methods/Examples/adts/hashtbl.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/adts/hashtbl.scm'\"
else
echo shar: Extracting \"'methods/Examples/adts/hashtbl.scm'\" \(2049 characters\)
sed "s/^X//" >'methods/Examples/adts/hashtbl.scm' <<'END_OF_FILE'
X;;; hash tbl.scm -- basic hash table object type
X;;; Brian Beckman, 11 Aug 1989
X
X(load "methods.scm")
X(load "assocl.scm")
X
X(define (new-hash-tbl size hash-func)
X  
X  (let* ( (tbl (make-vector size))
X          (supers '()) )
X    
X    (define (install item)
X      (let ( (k (hash-func (car item))) )
X        (vector-set! tbl k (cons item (vector-ref tbl k)))
X        self))
X
X    (define (retrieveq key)
X      (assql key (vector-ref tbl (hash-func key))))
X
X    (define (retrievev key)
X      (assvl key (vector-ref tbl (hash-func key))))
X
X    (define (retrieve key)
X      (assocl key (vector-ref tbl (hash-func key))))
X
X    (define (retrieve-raw key)
X      (vector-ref tbl (hash-func key)))
X
X    (define (print)
X      (display tbl) (newline) self)
X
X    (define (clear)
X      (set! tbl (make-vector size))
X      self)
X    
X    (define (self msg)
X      (cond
X       ( (eq? msg 'print)         print            )
X       ( (eq? msg 'install)       install          )
X       ( (eq? msg 'retrieveq)     retrieveq        )
X       ( (eq? msg 'retrievev)     retrievev        )
X       ( (eq? msg 'retrieve)      retrieve         )
X       ( (eq? msg 'retrieve-raw)  retrieve-raw     )
X       ( (eq? msg 'clear)         clear            )
X       ( (search-supertypes supers msg)            )
X       ( else (make-error-method "Hash-tbl" msg) )))
X    
X    self))
X
X(define h (new-hash-tbl 16 (lambda (n) (remainder n 16))))
X(define (test)
X  (load "hashtbl.scm")
X  (send h 'install '( 1 a))
X  (send h 'install '(17 b))
X  (send h 'install '( 0 c))
X  (send h 'install '( 2 d))
X  (send h 'install '( 3 e))
X  (send h 'install '(19 f))
X  (send h 'install '(35 g))
X  (send h 'install '( 2 h))
X  (send h 'install '( 1 i))
X  (send h 'install '( 1 j))
X  (send h 'install '( 2 k))
X  (send h 'install '(16 l))
X  (send h 'install '(16 m))
X  (send h 'install '( 0 n))
X  (send h 'install '( 0 o))
X  (send h 'install '( 0 p))
X  (send h 'print)
X  (display (send h 'retrieveq 17)) (newline)
X  (display (send h 'retrieveq  1)) (newline)
X  (display (send h 'retrieveq  4)) (newline)
X  )
END_OF_FILE
if test 2049 -ne `wc -c <'methods/Examples/adts/hashtbl.scm'`; then
    echo shar: \"'methods/Examples/adts/hashtbl.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/adts/hashtbl.scm'
fi
if test -f 'methods/Examples/adts/heap.sch' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/adts/heap.sch'\"
else
echo shar: Extracting \"'methods/Examples/adts/heap.sch'\" \(3039 characters\)
sed "s/^X//" >'methods/Examples/adts/heap.sch' <<'END_OF_FILE'
X;;;  H E A P . S C H
X;;;  Brian Beckman, JPL, 11 Nov 1987
X;;;  A little laboratory for fiddling around with heap-form trees.
X;;;  (see Bentley, Programming Pearls, Addison Wesley, 1986, Ch 12)
X
X; A heap is a list: (current-size  max-size  vector-containing-tree)
X;
X; rules are: heap index varies from 1 to current-size, inclusive
X;   (vector indices vary from 0 to n-1) -- 
X;   check current-size when heap is accessed.
X;
X; current-size must be less than max size
X;   check this when heap is updated.
X
X
X(define (make-heap max-size)
X  (list  0  max-size  (make-vector max-size 0)))
X
X
X; Here are some essential operators on heaps
X; --------------------------------------------------------------------
X
X
X(define root 1)
X
X
X(define (index-too-far? heap i)
X  (let
X    ((current-size (car heap)))
X    (or
X     (< i root)
X     (> i current-size))))
X
X
X(define (value heap i)
X  (let
X    ((vec (caddr heap)))
X    (if (index-too-far? heap i)
X        ()
X        (vector-ref vec (1- i)))))
X
X
X;; index thingies
X
X(define (left-child i)
X  (* 2 i))
X
X(define (right-child i)
X  (1+ (left-child i)))
X
X(define (parent i)
X  (quotient i 2))
X
X
X;; ordering stuff
X
X(define (order-routine a b)  ;; change this to use a different ordering
X  (<= a b))
X
X(define (in-order-node? heap node)  ;; is a give node in order ?
X  (order-routine
X   (value heap (parent node))
X   (value heap node)))
X
X
X;; heap constructors and modifiers
X
X(define (set-node! heap node val)  ;; set heap's node to val
X  (let
X    ((vec (caddr heap)))
X    (if index-too-far? heap node)
X      (begin (display "Heap Error (set-node!): invalid index!") 
X             (newline) ())  ;; return nil
X      (begin (vector-set! vec (1- node) val) val))))  ;; return val
X
X
X; Here is the meat of the algorithm -- sift-up and insert-in-heap
X; --------------------------------------------------------------------
X
X(define sift-up!
X  
X  (lambda (heap i) 
X    
X    (let
X      ((mom (parent i))
X       (temp 0))  ;; local variable for later use
X      
X      (if (=? i root)
X          #!true
X          
X          (if (in-order-node? heap i)
X              #!true
X              
X              (begin  ;; swap i with parent, then sift parent
X               (set! temp (value heap mom))
X               (set-node! heap mom (value heap i))
X               (set-node! heap i temp)
X               (sift-up! heap mom)))))))
X
X
X(define insert-in-heap!
X  (lambda (heap number)
X    
X    (define (cant-expand? heap)  ;; local routine
X      (let
X        ((max-size (cadr heap))
X         (current-size (car heap)))
X         (> (1+ current-size) max-size)))
X    
X    (if (cant-expand? heap)
X        (begin
X         (display "Heap Error (insert-in-heap): no room!")
X         (newline)
X         ())
X        
X        (begin
X         (set-car! heap (1+ (car heap)))      ;; bump current-size
X         (set-node! heap (car heap) number)   ;; set last element
X         (sift-up! heap (car heap))))))       ;; sift last elt up
X
X
X
X(define insert-random!
X  (lambda (heap limit)
X    (insert-in-heap! heap (random limit))
X    heap))  ;; return heap
END_OF_FILE
if test 3040 -ne `wc -c <'methods/Examples/adts/heap.sch'`; then
    echo shar: \"'methods/Examples/adts/heap.sch'\" unpacked with wrong size!
fi
# end of 'methods/Examples/adts/heap.sch'
fi
if test -f 'methods/Examples/adts/lin-tform.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/adts/lin-tform.scm'\"
else
echo shar: Extracting \"'methods/Examples/adts/lin-tform.scm'\" \(126 characters\)
sed "s/^X//" >'methods/Examples/adts/lin-tform.scm' <<'END_OF_FILE'
X(define (lin-tform x0 y0 x1 y1)
X  (let ( (dy/dx (/ (- y1 y0) (- x1 x0))) )
X    (lambda (x)
X      (+ y0 (* dy/dx (- x x0))))))
END_OF_FILE
if test 126 -ne `wc -c <'methods/Examples/adts/lin-tform.scm'`; then
    echo shar: \"'methods/Examples/adts/lin-tform.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/adts/lin-tform.scm'
fi
if test -f 'methods/Examples/adts/queues.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/adts/queues.scm'\"
else
echo shar: Extracting \"'methods/Examples/adts/queues.scm'\" \(2727 characters\)
sed "s/^X//" >'methods/Examples/adts/queues.scm' <<'END_OF_FILE'
X;================================================================
X;| Dr. Brian Beckman              | brian@topaz.jpl.nasa.gov    |
X;| Computer Graphics Laboratory   | (818) 397-9207              |
X;| Mail Stop 510-202              | (818) 397-9344              |
X;| Jet Propulsion Laboratory      |                             |
X;| Pasadena, CA 91109             | 3 July 1989                 |
X;================================================================
X
X;;; Adapted from Abelson & Sussman, Ch. 3, Pg 208 ff.
X;;; Uses the ``methods'' OOP package.  This is an expanded,
X;;; industrial-strength solution to Exercise 3.22 of A & S.
X
X(define (new-queue . initial-list)
X  
X  (let (  (q (cons () ()))
X          (initial-list (cond
X                          ( (null? initial-list) initial-list )
X                          ( else (car initial-list) )))
X          (supers ())  )
X    
X    (define (head) (car q))
X    (define (tail) (cdr q))
X    (define (set-head! item) (set-car! q item))
X    (define (set-tail! item) (set-cdr! q item))
X    
X    (define (empty-queue?) (null? (head)))
X    
X    (define (front)
X      (if (empty-queue?)
X          (error "FRONT called on empty queue")
X          (car (head))))
X    
X    (define (front!)    ;;; Remove front element and return it.
X      (let ((f (front)))
X        (remove-queue!)
X        f))
X    
X    (define (append-queue! item)
X      (let ((elt (cons item ())))  ; could be (list item)
X        (cond
X         (  (empty-queue?)
X            (set-head! elt)
X            (set-tail! elt)  
X            self  )
X         (  else
X            (set-cdr! (tail) elt)
X            (set-tail! elt)  
X            self  ))))
X    
X    (define (append-list! lyst)
X      (for-each append-queue! lyst)
X      self)
X    
X    (define (remove-queue!)
X      (cond
X       (  (empty-queue?)
X          (error "REMOVE called on empty queue")  )
X       (  else
X          (set-head! (cdr (head)))  self)))
X    
X    (define (clear-queue!)
X      (set! q (cons () ()))
X      self)
X    
X    (define (print) (display (head)) (newline))
X    
X    (define (self msg)
X      (cond
X       (  (eq? msg 'append!)       append-queue!  )
X       (  (eq? msg 'empty?)        empty-queue?   )
X       (  (eq? msg 'remove!)       remove-queue!  )
X       (  (eq? msg 'clear!)        clear-queue!   )
X       (  (eq? msg 'front)         front  )
X       (  (eq? msg 'front!)        front! )
X       (  (eq? msg 'print)         print  )
X       (  (eq? msg 'list)          (lambda () (head))  )
X       (  (eq? msg 'append-list!)  append-list!  )
X       (  (search-supertypes supers msg)  )
X       (  else  (make-error-method "Queue" msg)  )))
X    
X    (append-list! initial-list)  ;;; returns ``self''
X    
X    ))
X    ;;; end of new-queue
END_OF_FILE
if test 2727 -ne `wc -c <'methods/Examples/adts/queues.scm'`; then
    echo shar: \"'methods/Examples/adts/queues.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/adts/queues.scm'
fi
if test -f 'methods/Examples/adts/sets.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/adts/sets.scm'\"
else
echo shar: Extracting \"'methods/Examples/adts/sets.scm'\" \(1068 characters\)
sed "s/^X//" >'methods/Examples/adts/sets.scm' <<'END_OF_FILE'
X(define (new-set . initial-list)
X  
X  (let* ( (ivar '()) )
X
X    (define (list-o-set) ivar)
X
X    (define (put-set! obj)
X      (cond
X        ( (member obj ivar) self )
X        ( else (set! ivar (cons obj ivar)) self )))
X
X    (define (take-set obj)
X      (set! ivar
X        (let iter ( (L ivar) )
X          (cond
X            ( (null? L) '() )
X            ( (equal? obj (car L)) (iter (cdr L)) )
X            ( else (cons (car L) (iter (cdr L))) ))))
X      self)
X
X    (define (put-list! L)
X      (for-each put-set! L) self)
X
X    (define (member-set? obj)
X      (if (member obj ivar) #t #f))
X
X    (define (clear!)
X      (set! ivar '()))
X      
X    (define (self msg)
X      (cond
X       ( (eq? msg 'list)          list-o-set    )
X       ( (eq? msg 'put!)          put-set!      )
X       ( (eq? msg 'take!)         take-set      )
X       ( (eq? msg 'clear!)        clear!        )
X       ( (eq? msg 'put-list!)     put-list!     )
X       ( (eq? msg 'member?)       member-set?   )
X       ( else  (make-error-method "set" msg) )))
X
X    (put-list! initial-list)
X    
X    self))
END_OF_FILE
if test 1068 -ne `wc -c <'methods/Examples/adts/sets.scm'`; then
    echo shar: \"'methods/Examples/adts/sets.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/adts/sets.scm'
fi
if test ! -d 'methods/Examples/dataflow' ; then
    echo shar: Creating directory \"'methods/Examples/dataflow'\"
    mkdir 'methods/Examples/dataflow'
fi
if test ! -d 'methods/Examples/matrices' ; then
    echo shar: Creating directory \"'methods/Examples/matrices'\"
    mkdir 'methods/Examples/matrices'
fi
if test -f 'methods/Examples/matrices/vectors.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/matrices/vectors.scm'\"
else
echo shar: Extracting \"'methods/Examples/matrices/vectors.scm'\" \(443 characters\)
sed "s/^X//" >'methods/Examples/matrices/vectors.scm' <<'END_OF_FILE'
X;;; vectors.scm -- vector and matrix stuff
X;;; Brian Beckman, 9 Aug 1989
X
X(define (v-copy vec)
X  (let* ( (L (vector-length vec))
X          (V (make-vector L)) )
X    (do ( (i 0 (1+ i)) )
X        ( (= i L)  V )
X        (vector-set! V i (vector-ref vec i)))))
X
X(define (v-unop vec op)
X  (let ( (L (vector-length vec))
X         (V (v-copy vec)) )
X    (do ( (i 0 (1+ i)) )
X        ( (= i L)  V )
X        (vector-set! V i (op (vector-ref vec i))))))
END_OF_FILE
if test 444 -ne `wc -c <'methods/Examples/matrices/vectors.scm'`; then
    echo shar: \"'methods/Examples/matrices/vectors.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/matrices/vectors.scm'
fi
if test ! -d 'methods/Examples/receptionist' ; then
    echo shar: Creating directory \"'methods/Examples/receptionist'\"
    mkdir 'methods/Examples/receptionist'
fi
if test -f 'methods/Examples/receptionist/receptionist.s' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/receptionist/receptionist.s'\"
else
echo shar: Extracting \"'methods/Examples/receptionist/receptionist.s'\" \(75 characters\)
sed "s/^X//" >'methods/Examples/receptionist/receptionist.s' <<'END_OF_FILE'
X(load "methods.s")
X(load-if-not-bound 'new-receptionist "receptionist.scm")
END_OF_FILE
if test 76 -ne `wc -c <'methods/Examples/receptionist/receptionist.s'`; then
    echo shar: \"'methods/Examples/receptionist/receptionist.s'\" unpacked with wrong size!
fi
# end of 'methods/Examples/receptionist/receptionist.s'
fi
if test -f 'methods/Examples/receptionist/receptionist.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/receptionist/receptionist.scm'\"
else
echo shar: Extracting \"'methods/Examples/receptionist/receptionist.scm'\" \(9597 characters\)
sed "s/^X//" >'methods/Examples/receptionist/receptionist.scm' <<'END_OF_FILE'
X;;; receptionist.scm -- an object type for event mgt and dispatching.
X;;; Brian Beckman, 13 Aug 1989
X
X;;----------------------------------------------------------------------;;
X;;                                                                      ;;
X;;                        R E C E P T I O N I S T                       ;;
X;;                                                                      ;;
X;;----------------------------------------------------------------------;;
X
X; The receptionist controls access to the event service resources of
X; the application.  The receptionist also disciplines access to the
X; system's event queue, hiding system-dependent details.  The
X; receptionist keeps a data base of workers.  Each workers
X; is a triple:
X; 
X;     (device-number event-fender event-handler), abbreviated to
X;     (dn ef eh)
X; 
X; An event-handler is called by the receptionist when the device
X; denoted by device-number generates a low-level event and when the
X; event-fender returns true (#t).
X; 
X; Device-number is a system-dependent device number, denoting a
X; physical or logical device such as a mouse button or keyboard.
X; Device number 0 is reserved for null events.  Handlers for null
X; events are ``background processes''.  They are called only when the
X; low-level event queue is empty.  A low-level event is a pair
X; 
X;     (device-number device-data), abbreviated to
X;     (dn dd)
X; 
X; Event-fender is a boolean function of one argument returning true
X; when the corresponding event-handler is to be called.  The argument
X; is the low-level event found by the receptionist.  Event-fenders are
X; used to refine the definition of an event, for example by checking
X; whether a mouse hit was in a certain on-screen object such as a
X; button or slider.  A low-level event plus an event-fender together
X; define a high-level, or user-defined event.
X; 
X; Event-handler is a function of one argument -- a low-level event --
X; that processes the detected, or ``fended'' event.  The event-handler 
X; performs whatever application-dependent actions are to be associated
X; with a high-level event.  Given a low-level event, the receptionist
X; will check all event services with a matching device-number, and
X; will call all event-handlers whose fenders evaluate to true for that
X; low-level event.
X; 
X; The event service data base is organized as a binary search table.
X; 
X;     #( (dn (ef eh) ...)  ...)
X
X(set! **standard-breakout-continuation** '())
X
X(define (new-receptionist . initial-workers)
X  
X  (let* ( (maxsize 16)
X          (size 1)
X          (tbl (make-vector maxsize)) 
X          (dummy (vector-set! tbl 0 '(0)))
X          (supers '()) )
X    
X    ; Global Invariant: element 0 of tbl always contains the
X    ; workers for the null event.  That is, it always contains the
X    ; list (0 (ef eh) ...).  
X
X    ;;; local binary search invariants:
X    ;;; min >= 0, max < size,
X    ;;; min <= mid <= max.
X    ;;; OK by the global invariant 
X
X    (define (index-search key)
X      (let iter ( (min 0) (max (-1+ size)) )
X        (let* ( (mid  (quotient (+ min max) 2))
X                (v    (vector-ref tbl mid))
X                (test (car v)) )
X          (cond
X           ( (= key test)  mid                  )
X           ( (>= min max)  '()                  )
X           ( (< key test)  (iter min (-1+ mid)) )
X           ( else          (iter (1+ mid) max)  )))))
X
X    (define (search key)
X      (let iter ( (min 0) (max (-1+ size)) )
X        (let* ( (mid  (quotient (+ min max) 2))
X                (v    (vector-ref tbl mid))
X                (test (car v)) )
X          (cond
X           ( (= key test)  v                    )
X           ( (>= min max)  '()                  )
X           ( (< key test)  (iter min (-1+ mid)) )
X           ( else          (iter (1+ mid) max)  )))))
X
X ;   (define search
X ;     (let ( (last-hit -1) )
X ;       (lambda (key)
X ;         (if (= key last-hit)
X ;             (vector-ref tbl last-hit)
X ;             (let iter ( (min 0) (max (- size 1)) )
X ;               (let* ( (mid  (quotient (+ min max) 2))
X ;                       (v    (vector-ref tbl mid))
X ;                       (test (car v)) )
X ;                 (cond
X ;                  ( (= key test)  (set! last-hit (car v)) v  )
X ;                  ( (>= min max)  '()                        )
X ;                  ( (< key test)  (iter min (-1+ mid))       )
X ;                  ( else          (iter (1+ mid) max) ))))))))
X
X    (define (swap i j)
X      (let ( (t (vector-ref tbl i)) )
X        (vector-set! tbl i (vector-ref tbl j))
X        (vector-set! tbl j t)))
X    
X    (define (check) ;;; check the invariant
X      (unless (= (car (vector-ref tbl 0)) 0)
X              (error "Receptionist must always have a null worker")))
X    
X    (define (sift-in worker)
X      ;;; precondition -- maxsize > size
X      (vector-set! tbl size (list (car worker) (cdr worker)))
X      (let iter ( (i (-1+ size)) )
X        (cond
X         ( (= i 0)  (check) )
X         ( (< (car (vector-ref tbl (1+ i)))
X              (car (vector-ref tbl i)))
X           (swap i (1+ i)) (iter (-1+ i)) )
X         ( else (check) )))
X      (set! size (1+ size)))
X
X    (define (rif-department dev)
X      (let ( (lookup (search dev)) )
X        ;(pr lookup (index-search dev) (- size 2))
X        (when lookup
X          (for (i from (index-search dev) thru (- size 2))
X            (vector-set! tbl i (vector-ref tbl (add1 i))))
X          (set! size (sub1 size))
X          (vector-set! tbl size '())
X        )
X      )
X      (check)
X      self
X    )
X
X    (define (fire worker)
X      (let ( (lookup (search (car worker))) )
X        (when lookup
X          (set-cdr! lookup 
X            (let ( (lyst (cdr lookup))
X                   (obj  (cdr worker)) )
X              (let iter ( (l lyst) )
X                (cond
X                  ( (null? l) '() )
X                  ( (equal? obj (car lyst)) (iter (cdr lyst)) )
X                  ( else (cons (car lyst) (iter (cdr lyst))) )))))))
X      self)
X
X    (define (install worker)
X      (let ( (lookup (search (car worker))) )
X        (cond
X
X         ( lookup 
X           (vector-set! 
X            tbl 
X            (index-search (car worker))
X            (cons (car lookup) (cons (cdr worker) (cdr lookup)))) )
X
X         ( (= size maxsize)
X           (set! maxsize (* maxsize 2))
X           (let ( (temp (make-vector maxsize)) )
X             (for (i from 0 to size)
X                  (vector-set! temp i (vector-ref tbl i)))
X             (set! tbl temp))
X           (sift-in worker) )
X
X         ( else (sift-in worker) )))
X
X      (qdevice (car worker))
X      self)
X    
X    (define (show sym val)
X      (display sym) (display " = ") (display val) (newline))
X    
X    (define (print)
X      (show 'size size)
X      (show 'maxsize maxsize)
X      (display "#(") (newline)
X      (for (i from 0 to size)
X           (display " ")
X           (display (vector-ref tbl i))
X           (newline))
X      (display ")")
X      (newline))
X
X    (define (iter-worker w data)
X      (cond
X        ( (null? w) )
X        ( ((caar w) data) ((cadar w) data)
X            (iter-worker (cdr w) data) )
X        ( else
X            (iter-worker (cdr w) data) ) ))
X
X    (define (loop breakout-continuation)
X      (qreset)
X      (set! **standard-breakout-continuation** breakout-continuation)
X      (while #t
X        (let ( (esr (search (qtest))) )
X          ;(display esr) (newline)  
X          (cond
X            ( (null? esr) (qread) ) ;;; trash the event
X            ( (= 0 (car esr)) (iter-worker (cdr esr) '(0 0)) )
X            ( else (iter-worker (cdr esr) (qread)) )))))
X
X    (define (enter-loop)
X      (call-with-current-continuation loop))
X
X    (define (self msg)
X      (cond
X       ( (eq? msg 'install)      install         )
X       ( (eq? msg 'retrieve)     search          )
X       ( (eq? msg 'rif-dev)      rif-department  )
X       ( (eq? msg 'rif)          fire            )
X       ( (eq? msg 'print)        print           )
X       ( (eq? msg 'table)        (lambda () tbl) )
X       ( (eq? msg 'enter-loop)   enter-loop      )
X       ( (search-supertypes supers msg)          )
X       ( else  (make-error-method "Receptionist" msg) )))
X
X    (for-each install initial-workers)
X
X    self))
X    
X;;----------------------------------------------------------------------;;
X;;                     g e n e r i c   f e n d e r s                    ;;
X;;----------------------------------------------------------------------;;
X
X(define (always data) #t)
X(define (never data)  #f)
X(define (button-down data) (= (cadr data) 1))
X(define (button-up   data) (= (cadr data) 0))
X
X;;----------------------------------------------------------------------;;
X;;             g e n e r i c   Q u i t t e r   h a n d l e r            ;;
X;;----------------------------------------------------------------------;;
X
X(define (standard-quitter data)
X   (**standard-breakout-continuation** #t))
X
X(define standard-quit-worker (list ESCKEY always standard-quitter))
X
X;;----------------------------------------------------------------------;;
X;;              H a r d   l o o p i n g   c o n s t r u c t             ;;
X;;----------------------------------------------------------------------;;
X
X(define (do-until-event data thunk)
X
X  (let ( (dev (car data))
X         (val (cadr data))
X       )
X
X    (qdevice dev)
X
X    (let iter ( (q (qtest)) )
X
X      (cond
X
X        ( (= q 0) (thunk) (iter (qtest)) ) ;; nothing in queue
X
X        ( else (let ( (qr (qread)) )    ;; Read queue contents
X
X                 (cond 
X
X                   ( (and (= q dev) (= val (cadr qr))) 'done )
X
X                   ( else (thunk) (iter (qtest)) ))) )))))
X
X
END_OF_FILE
if test 9597 -ne `wc -c <'methods/Examples/receptionist/receptionist.scm'`; then
    echo shar: \"'methods/Examples/receptionist/receptionist.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/receptionist/receptionist.scm'
fi
if test ! -d 'methods/Examples/utils' ; then
    echo shar: Creating directory \"'methods/Examples/utils'\"
    mkdir 'methods/Examples/utils'
fi
if test -f 'methods/Examples/utils/Stream.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/utils/Stream.scm'\"
else
echo shar: Extracting \"'methods/Examples/utils/Stream.scm'\" \(3128 characters\)
sed "s/^X//" >'methods/Examples/utils/Stream.scm' <<'END_OF_FILE'
X;;; Section 3.4   S T R E A M S   page 242 ff.
X
X;;; at first, streams are implemented as ordinary lists
X
X;;; the following variables create the representation for streams
X
X(define cons-stream cons)
X(define head car)
X(define tail cdr)
X(define empty-stream? null?)
X(define the-empty-stream ())
X
X;;; the following variables are abstract operators on streams, independent
X;;; of the representation above (I hope :-)
X
X(define (append-streams s1 s2)
X  (cond
X   (  (empty-stream? s1)  s2  )
X   (  t  (cons-stream (head s1) (append-streams (tail s1) s2)))))
X
X(define (accumulate combiner initial-value stream)
X  (cond
X   (  (empty-stream? stream)  initial-value  )
X   (  t  (combiner 
X          (head stream)
X          (accumulate combiner initial-value (tail stream)))  )))
X
X(define (flatten stream)
X  (accumulate append-streams the-empty-stream stream))
X
X(define (horner-eval x coeff-stream)
X  (define (add-term coeff higher-terms)
X    (+ coeff (* x higher-terms)))
X  (accumulate add-term 0 coeff-stream))
X
X(define (map-stream proc stream)
X  (cond
X   (  (empty-stream? stream)  the-empty-stream  )
X   (  t  (cons-stream
X          (proc (head stream))
X          (map-stream proc (tail stream)))  )))
X
X(define (filter-stream predicate? stream)
X  (cond
X   (  (empty-stream? stream)  the-empty-stream  )
X   (  (predicate? (head stream))
X        (cons-stream 
X         (head stream) 
X         (filter-stream predicate? (tail stream)))  )
X   (  t  (filter-stream predicate? (tail stream))  )))
X
X(define (for-each-stream proc stream)  ;; NO OUTPUT; FOR SIDE-EFFECTS ONLY
X  (cond
X   (  (empty-stream? stream)  'done  )
X   (  t  (begin
X          (proc (head stream))
X          (for-each-stream proc (tail stream)))  )))
X
X(define (enumerate-interval low high)
X  (if (> low high)
X      the-empty-stream
X      (cons-stream low (enumerate-interval (1+ low) high))))
X
X;;; page 251, Ex. 3.38
X
X(define (left-accumulate combiner initial-value stream)
X  (cond
X   (  (empty-stream? stream)  initial-value  )
X   (  t  (left-accumulate combiner
X                          (combiner initial-value (head stream))
X                          (tail stream))  )))
X
X;;; page 252, Ex. 3.39
X
X(define (accumulate-n op init streams)  ;; CROSS-SECTION ACROSS
X  (cond                                 ;; A STREAM OF STREAMS
X   (  (empty-stream? (head streams))  the-empty-stream  )
X   (  t  (cons-stream
X          (accumulate
X           op
X           init
X           (map-stream head streams))
X          (accumulate-n
X           op
X           init
X           (map-stream tail streams)))  )))
X
X;;; page 253
X
X(enumerate-interval 1 100)
X
X(define (pairs-no-flatten n)
X  (map-stream
X   (lambda (i)
X     (map-stream (lambda (j) (list i j))
X                 (enumerate-interval 1 (-1+ i))))
X   (enumerate-interval 1 n)))
X
X(define (stream-of-pairs n)
X  (flatten
X   (map-stream
X    (lambda (i)
X      (map-stream (lambda (j) (list i j))
X                  (enumerate-interval 1 (-1+ i))))
X    (enumerate-interval 1 n))))
X
X(define (flatmap f s) (flatten (map f s)))
X
X;;; THE DEFINITION OF THE SPECIAL FORM "COLLECT", PAGE 256, AS A MACRO, IS
X;;; A FAIRLY BIG JOB.  SOME OTHER TIME.
X
END_OF_FILE
if test 3128 -ne `wc -c <'methods/Examples/utils/Stream.scm'`; then
    echo shar: \"'methods/Examples/utils/Stream.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/utils/Stream.scm'
fi
if test -f 'methods/Examples/utils/assocl.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/utils/assocl.scm'\"
else
echo shar: Extracting \"'methods/Examples/utils/assocl.scm'\" \(467 characters\)
sed "s/^X//" >'methods/Examples/utils/assocl.scm' <<'END_OF_FILE'
X(define (<-filter-> pred? lyst)
X  (cond
X    ( (null? lyst) '() )
X    ( (pred? (car lyst))
X      (cons (car lyst)
X            (<-filter-> pred? (cdr lyst))) )
X    ( else  (<-filter-> pred? (cdr lyst)) )))
X
X(define (assql obj alist)
X  (<-filter-> (lambda (pair) (eq? (car pair) obj)) alist))
X
X(define (assvl obj alist)
X  (<-filter-> (lambda (pair) (eqv? (car pair) obj)) alist))
X
X(define (assocl obj alist)
X  (<-filter-> (lambda (pair) (equal? (car pair) obj)) alist))
END_OF_FILE
if test 467 -ne `wc -c <'methods/Examples/utils/assocl.scm'`; then
    echo shar: \"'methods/Examples/utils/assocl.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/utils/assocl.scm'
fi
if test -f 'methods/Examples/utils/copy-list.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/utils/copy-list.scm'\"
else
echo shar: Extracting \"'methods/Examples/utils/copy-list.scm'\" \(219 characters\)
sed "s/^X//" >'methods/Examples/utils/copy-list.scm' <<'END_OF_FILE'
X(define (copy lyst) (apply list lyst))
X
X(define (copy* lyst) 
X  (cond
X    ( (null? lyst) '() )
X    ( (list? (car lyst)) (cons (copy* (car lyst)) (copy* (cdr lyst))) )
X    ( else (cons (car lyst) (copy* (cdr lyst))) )))
END_OF_FILE
if test 219 -ne `wc -c <'methods/Examples/utils/copy-list.scm'`; then
    echo shar: \"'methods/Examples/utils/copy-list.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/utils/copy-list.scm'
fi
if test -f 'methods/Examples/utils/mouse-o-meter.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/utils/mouse-o-meter.scm'\"
else
echo shar: Extracting \"'methods/Examples/utils/mouse-o-meter.scm'\" \(559 characters\)
sed "s/^X//" >'methods/Examples/utils/mouse-o-meter.scm' <<'END_OF_FILE'
X(load "receptionist.s")
X
X(define (mouse-o-meter)
X  (let ((r (new-receptionist standard-quit-worker))
X        (w (begin (prefposition 8 350 927 990) (winopen "mouse-o-meter"))))
X    (erase MAGENTA)
X    (cmov2 10 40)
X    (color BLACK)
X    (charstr "Type ESC with mouse in this window")
X    (cmov2 10 20)
X    (charstr "to end the mouse-O-meter program.")
X    (send r 'install
X          (list 0 always
X                (lambda (data)
X                  (pr (list (getvaluator MOUSEX) (getvaluator MOUSEY))))))
X    (send r 'enter-loop)
X    (winclose (winget))))
X
X  
END_OF_FILE
if test 559 -ne `wc -c <'methods/Examples/utils/mouse-o-meter.scm'`; then
    echo shar: \"'methods/Examples/utils/mouse-o-meter.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/utils/mouse-o-meter.scm'
fi
if test -f 'methods/Examples/utils/qsort.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/utils/qsort.scm'\"
else
echo shar: Extracting \"'methods/Examples/utils/qsort.scm'\" \(641 characters\)
sed "s/^X//" >'methods/Examples/utils/qsort.scm' <<'END_OF_FILE'
X(define (shelsort vec len bin-op)
X
X  (cond
X    ( (<= 1 len)  vec )
X    ( else
X
X      (do ( (gap (quotient len 2) (quotient gap 2)) )
X          ( (= 0 gap) vec )
X
X          (do ( (i gap (1+ i)) )
X              ( (>= len i) )
X
X              (do ( (j (- i gap) (- j gap)) )
X                  ( (< 0 j) )
X
X                  (let ( (x (vector-ref vec j))
X                         (y (vector-ref vec (+ j gap))) )
X                    (cond
X                      ( (> 0 (bin-op x y)) 
X                        (vector-set! vec j y)
X                        (vector-set! vec (+ j gap) x) )))))) )))
X                        
X                          
END_OF_FILE
if test 641 -ne `wc -c <'methods/Examples/utils/qsort.scm'`; then
    echo shar: \"'methods/Examples/utils/qsort.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/utils/qsort.scm'
fi
if test -f 'methods/Examples/utils/shelsort.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/Examples/utils/shelsort.scm'\"
else
echo shar: Extracting \"'methods/Examples/utils/shelsort.scm'\" \(1210 characters\)
sed "s/^X//" >'methods/Examples/utils/shelsort.scm' <<'END_OF_FILE'
X(define (vrand len max)
X  (let ((x (make-vector len)))
X    (for (i from 0 to len)
X         (vector-set! x i (random max)))
X    x))
X
X(define (shelsort vec len bin-op)
X
X  (cond
X    ( (<= len 1)  vec )
X    ( else
X
X      (do ( (gap (quotient len 2) (quotient gap 2)) )
X          ;;; Go down by powers of two.  Gap will always be equal
X          ;;; to 1 eventually.  A gap of one is sufficient to guarantee
X          ;;; sorting.
X          ( (= 0 gap) vec )
X
X          (for (i from gap to len)
X
X              (for (j from (- i gap) down thru 0 by gap)
X
X                  (let ( (x (vector-ref vec j))
X                         (y (vector-ref vec (+ j gap))) )
X                    (cond
X                      ( (bin-op x y)
X                        (vector-set! vec j y)
X                        (vector-set! vec (+ j gap) x) )))))) )))
X                        
X(define (binary-search-int vec len elt)
X  (let iter ( (min 0)
X              (max (- len 1)) )
X    (let* ( (mid (quotient (+ min max) 2))
X            (test (vector-ref vec mid)) )
X      (cond
X       ( (= elt test)  (list mid test) )
X       ( (>= min max)  '() )
X       ( (< elt test)  (iter min (-1+ mid)) )
X       ( else          (iter (1+ mid) max)  )))))
END_OF_FILE
if test 1211 -ne `wc -c <'methods/Examples/utils/shelsort.scm'`; then
    echo shar: \"'methods/Examples/utils/shelsort.scm'\" unpacked with wrong size!
fi
# end of 'methods/Examples/utils/shelsort.scm'
fi
if test -f 'methods/methods.dox' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/methods.dox'\"
else
echo shar: Extracting \"'methods/methods.dox'\" \(9291 characters\)
sed "s/^X//" >'methods/methods.dox' <<'END_OF_FILE'
X;************************************************************
X;                                                           *
X; Copyright (c) 1990, California Institute of Technology.   *
X; U.S. Government Sponsorhip under NASA Contract NAS7-918   *
X; is acknowledged.                                          *
X;                                                           *
X;***********************************************************/
X
X; methods.scm
X;
X; ===============================================================
X; Brian Beckman                  |    brian@topaz.jpl.nasa.gov
X; Mail Stop 510-202              |    (818) 397-9207
X; Jet Propulsion Laboratory      | 
X; Pasadena, CA 91109             |    30 June 1989
X; ===============================================================
X
X; INTRODUCTION
X;
X; This is a tiny object-oriented programming system with multiple
X; inheritance and error handling.  It is modeled after the message
X; passing modules in Chapter 3 of Abelson & Sussman.  It is 
X; implemented in ``pure'' Scheme, without macros or syntax
X; extensions.
X; 
X; This programming system is implemented as a technique, or
X; programming convention, with some helper routines.  The programming
X; convention is not enforced, as we choose to avoid syntax-extensions
X; for portability's sake.  
X; 
X; Every class is represented by its constructor procedure.  This
X; procedure returns a message dispatching procedure.  The message
X; dispatching procedure should be named ``self'' so that an object can
X; conveniently send messages to itself.  However, ``self'' is an
X; internal name not known outside the constructor.  
X; 
X; In summary, classes are represented by constructor procedures, and
X; objects, or instances of classes, are represented by message
X; dispatching procedures.  The present version of ``methods'' does not
X; support code sharing, so every instance of a class has its own
X; private copies of the method code.  We expect to implement code
X; sharing in a later version of ``methods''.
X; 
X; The message dispatching procedure walks the multiple inheritance
X; hierarchy upwards until it finds an object that can understand a
X; message, starting with itself.  If no object that can understand the
X; message is found, a global error procedure is called.
X; 
X; IMPLEMENTATION
X;
X; Error processing is challenging.  We should like to have two modes.
X; In ``normal mode'', an error is reported only by the first receiver
X; of a message.  In ``debug mode'', an inheritance traceback should be
X; given whereby every object in an inheritance hierarchy will report
X; when it fails to recognize a given message.  The following variable
X; represents that mode.  
X
X(define **method-mode** 'normal-method-mode)
X
X; The user can set these modes as follows.
X
X(define (set-debug-method-mode)
X  (set! **method-mode** 'debug-method-mode))
X
X(define (set-normal-method-mode)
X  (set! **method-mode** 'normal-method-mode))
X
X(define (reset-debug-method-mode)  ;;; synonym
X  (set! **method-mode** 'normal-method-mode))
X
X; and test them with the following routine:
X
X(define (test-debug-method-mode)
X  (eq? **method-mode** 'debug-method-mode))
X
X; Before presenting the examples of classes and objects, some helper
X; routines are needed.
X;
X; When an object cannot recognize a message, and none of its ancestor
X; objects can recognize it, the object creates an error procedure and
X; returns it as the result of the message dispatcher.  
X
X(define **method-error-class-name** "No class name.")
X
X(define **method-error-message** 'no-message)
X
X(define (error-method . junk-args)
X  (display **method-error-class-name**)
X  (display ": uknown message: '")
X  (display **method-error-message**)
X  (newline)
X  ())
X
X(define (make-error-method class-name msg)
X  (set! **method-error-class-name** class-name)
X  (set! **method-error-message** msg)
X  error-method)
X
X; The procedure that walks the inheritance hierarchy must cooperate
X; in the error handling.  
X
X(define (search-supertypes supers msg)
X  (define method ())
X  (if (test-debug-method-mode)
X      (begin
X       (display "Searching...")
X       (newline)))
X  (cond
X   (  (null? supers)  ()  )
X   (  (begin
X       (set! method ((car supers) msg))
X       (eq? method error-method))
X                      (if (test-debug-method-mode)
X                          (error-method))
X                      (search-supertypes (cdr supers) msg)  )
X   (  else  method  )))
X
X; This procedure implements the inheritance of methods.  It works as
X; follows.  A local variable, ``method'', is defined.  Its value is
X; not important to begin with.  If debugging is on, we print a
X; message telling the user that the inheritance hierarchy is being
X; searched.  Then, the list of supertypes is investigated.  If the
X; list is empty, we return nil, which signals the caller to create
X; and return the error-method, as we shall see in the examples
X; later.  If the list is not empty, we pass the message to the first
X; supertype in the list.  The return value is assigned to the local
X; variable ``method''.  If the returned method is the one and only
X; global error-method, then the supertype, and, recursively, all its
X; supertypes, did not know the message.  If debugging is on, we
X; execute the returned error-method, contributing to the
X; aforementioned inheritance traceback.  Finally, we return the value
X; of a recursive call of search-supertypes on the remainder of the
X; list of supertypes.  If the returned method is not the
X; error-method, then the supertype did understand the message after
X; all somewhere in the hierarchy, and the returned method is the
X; return value of this procedure.
X; 
X; Note that the list of supertypes is searched in order from front to
X; back.  The first match of a message results in the successful
X; finding of a method.  The order of supertypes in the list is
X; significant only when more than one supertype can understand a
X; given message.  The earlier members of the list will shadow the
X; later ones.  In some object-oriented programming systems, one
X; refers to the ``overriding'' of methods.  The shadowing in
X; ``methods'' is our form of method overriding, and it is under
X; explicit control of the programmer who sets the order of supertypes
X; in the list of supertypes.
X; 
X; In summary, search-supertypes passes the message to the ancestors,
X; in pre-order, returning the first method found.
X; 
X; The next helper routine passes a message, and a variable number of
X; arguments, to all the parents of an object.  For side effects, it
X; executes any methods found.  Parents are defined as first level
X; ancestors.
X
X(define (for-all-parents supers msg . args)
X  (let (  (method-list
X           (map (lambda (supertype) (supertype msg)) supers))
X          (for-proc
X           (lambda (method) (apply method args)))  )
X    (for-each for-proc method-list)))
X
X; With the current programming convention, it is not possible to pass
X; a message to all ancestors and execute the methods for side-effect
X; without explicit cooperation on the part of the objects involved. In
X; other words, the procedure ``for-all-ancestors'', analogous to
X; ``for-all-parents'', cannot be implemented in the current version of
X; the methods package.  The reason is that the convention calls for
X; every class to call ``search-supertypes'', which stops when it finds
X; a method.  The convention would have to be augmented so that objects
X; would call ``find-all-methods'' (defined below) on an appropriate
X; message.  Since we expect the need for ``for-all-ancestors'' to be
X; fairly rare, the necessary changes to the methods package will be
X; reserved for a future version.
X
X(define (find-all-methods supers msg)
X  (cond
X   (  (null? supers)  ()  )
X   (  else  (cons ((car supers) msg)
X                  (find-all-methods (cdr supers) msg))  )))
X
X; There are two ways to invoke a method in an object.  The
X; first is to send the object a message, getting back a procedure.
X; This procedure can then be invoked at will on an appropriate
X; set of arguments.  Such an idiom usually results in expressions
X; like the following:
X;
X;   ((foo 'do-it) arg1 arg2)
X;
X; This is fairly readable and a fine idiom, but it has its 
X; limitations.  Suppose that this expression were to result in
X; another object, to which we should like to send the message
X; 'baz with the arguments 'rat and 'ter.  Then we should write
X; the following:
X;
X;   ((((foo 'do-it) arg1 arg2) 'baz) 'rat 'ter)
X;
X; The number of leading parentheses is a problem.  It is easy 
X; to devise nested message passing expressions that are
X; much more difficult to write than to devise, merely because of
X; the number of leading parentheses that must be presaged.  Lisp 
X; already has a problem with closing parentheses; we don't want
X; to compound the felony in this package by introducing a 
X; corresponding problem with opening parentheses.  
X;
X; We need a ``send'' routine that does little more than reduce
X; the need for leading parenthese.  This is, admittedly, merely 
X; a syntactic issue.  Consider the following:
X
X(define (send object msg . args)
X  (apply (object msg) args))
X
X; The earlier example message passing expressions can now be
X; much more easly written much more nicely, as follows:
X;
X;    (send foo 'do-it arg1 arg2)
X;
X; and
X;
X;    (send (send foo 'do-it arg1 arg2) 'baz 'rat 'ter)
X
END_OF_FILE
if test 9291 -ne `wc -c <'methods/methods.dox'`; then
    echo shar: \"'methods/methods.dox'\" unpacked with wrong size!
fi
# end of 'methods/methods.dox'
fi
if test -f 'methods/methods.s' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/methods.s'\"
else
echo shar: Extracting \"'methods/methods.s'\" \(40 characters\)
sed "s/^X//" >'methods/methods.s' <<'END_OF_FILE'
X(load-if-not-bound 'send "methods.scm")
END_OF_FILE
if test 40 -ne `wc -c <'methods/methods.s'`; then
    echo shar: \"'methods/methods.s'\" unpacked with wrong size!
fi
# end of 'methods/methods.s'
fi
if test -f 'methods/methods.scm' -a "${1}" != "-c" ; then 
  echo shar: Will not clobber existing file \"'methods/methods.scm'\"
else
echo shar: Extracting \"'methods/methods.scm'\" \(2288 characters\)
sed "s/^X//" >'methods/methods.scm' <<'END_OF_FILE'
X;************************************************************
X;                                                           *
X; Copyright (c) 1990, California Institute of Technology.   *
X; U.S. Government Sponsorhip under NASA Contract NAS7-918   *
X; is acknowledged.                                          *
X;                                                           *
X;***********************************************************/
X
X; methods.scm
X; Brian Beckman                  |    brian@topaz.jpl.nasa.gov
X; Pasadena, CA 91109             |    30 June 1989
X
X(define **method-mode** 'normal-method-mode)
X
X(define (set-debug-method-mode)
X  (set! **method-mode** 'debug-method-mode))
X
X(define (set-normal-method-mode)
X  (set! **method-mode** 'normal-method-mode))
X
X(define (reset-debug-method-mode)  ;;; synonym
X  (set! **method-mode** 'normal-method-mode))
X
X(define (test-debug-method-mode)
X  (eq? **method-mode** 'debug-method-mode))
X
X(define **method-error-class-name** "No class name.")
X
X(define **method-error-message** 'no-message)
X
X(define (error-method . junk-args)
X  (display **method-error-class-name**)
X  (display ": uknown message: '")
X  (display **method-error-message**)
X  (newline)
X  ())
X
X(define (make-error-method class-name msg)
X  (set! **method-error-class-name** class-name)
X  (set! **method-error-message** msg)
X  error-method)
X
X(define (search-supertypes supers msg)
X  (define method ())
X  (if (test-debug-method-mode)
X      (begin
X       (display "Searching...")
X       (newline)))
X  (cond
X   (  (null? supers)  ()  )
X   (  (begin
X       (set! method ((car supers) msg))
X       (eq? method error-method))
X                      (if (test-debug-method-mode)
X                          (error-method))
X                      (search-supertypes (cdr supers) msg)  )
X   (  else  method  )))
X
X(define (for-all-parents supers msg . args)
X  (let (  (method-list
X           (map (lambda (supertype) (supertype msg)) supers))
X          (for-proc
X           (lambda (method) (apply method args)))  )
X    (for-each for-proc method-list)))
X
X(define (find-all-methods supers msg)
X  (cond
X   (  (null? supers)  ()  )
X   (  else  (cons ((car supers) msg)
X                  (find-all-methods (cdr supers) msg))  )))
X
X(define (send object msg . args)
X  (apply (object msg) args))
X
X
END_OF_FILE
if test 2288 -ne `wc -c <'methods/methods.scm'`; then
    echo shar: \"'methods/methods.scm'\" unpacked with wrong size!
fi
# end of 'methods/methods.scm'
fi
echo shar: End of archive 1 \(of 2\).
cp /dev/null ark1isdone
MISSING=""
for I in 1 2 ; do
    if test ! -f ark${I}isdone ; then
	MISSING="${MISSING} ${I}"
    fi
done
if test "${MISSING}" = "" ; then
    echo You have unpacked both archives.
    rm -f ark[1-9]isdone
else
    echo You still need to unpack the following archives:
    echo "        " ${MISSING}
fi
##  End of shell archive.
exit 0
